<?php
/**
 * Valida lancamento de AF
 */
namespace Compras\Logic\Fornecimento\Exception;

class FornecedorAF extends \Compras\Logic\Exception
{

    private $messageName;

    /**
     * Construtor.
     *
     * Recebe o nome da mensagem cadastrada no setforms.
     *
     * @param string $messageName
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct($messageName, $code = 0, \Exception $previous = null)
    {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;
    }


    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }


    /**
     * Fornecedor nao atende a filial
     * @static
     * @throws FornecedorAF
     */
    public static function fornecedorNaoAtendeFilial()
    {
        throw new self (tk_get_message_by_name("msg_cmp_fornecedor_nao_atende_filial"));
    }


    /**
     * Fornecedor nao atende a regiao
     * @static
     * @throws FornecedorAF
     */
    public static function fornecedorNaoAtendeRegiao()
    {
        throw new self (tk_get_message_by_name("msg_cmp_fornecedor_nao_atende_regiao"));
    }


}