var CalculoDaNecessidadeDeComprasController = function (ScreenService, MessageService, General, restEngine, templateManager, Utilities){
    /*global Constants*/
    var self = this;
    var idutcardpadr;
    var grupo;
    var idcalprevcon;
    var nececomp;
    var extra;
    var calculaSegundoPlano = false;
    
    
    this.validaDtinicial = function() {
        let widget = templateManager.container.getWidget('calculoNecessidadeComprasMerenda');
        let dataInicial = widget.currentRow.PERIENTR.start;
        if(dataInicial) {
            dataInicial = moment(dataInicial, 'DD/MM/YYYY');
            var dataProcessamento = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
            
            if(dataInicial < dataProcessamento) {
                MessageService.showMessageByCode("DTINIC_MENOR_DTPROC");
                return false;
            } else {
                return true;
            }
        }
    };
    
    this.setEstoque = function(field) {
        if(field.getParent().name == 'calculoNecessidadeComprasMerenda'){
            if(field.widget.currentRow.IDSCONESTNEC == 'S') {
    		    field.widget.getField('CONSIDERAESTOQUE').label = ScreenService.i18n('Considera Estoque');
    		} else {
    		    field.widget.getField('CONSIDERAESTOQUE').label = ScreenService.i18n('Não Considera Estoque');
    		}
    		field.widget.getField('PEACRESCIMO').readOnly = field.widget.currentRow.IDPERACRNEC == 'N';
        } else {
            let row = angular.copy(field.widget.currentRow);
            if(field.value().length > 0) {
                if(row.FILIAL.length == 1){
                    row.CDFILIAL = concatArrayForParams(row.FILIAL);
                    General.callRestEngine('cmp_necessidadeCompras#/setEstoque','Row', row).then(function(calback) {
                        let resposta = calback.dataset.resposta[0];
                        if(resposta) {
                            if(resposta.IDSCONESTNEC == 'S') {
                    		    field.widget.getField('estoque').label = ScreenService.i18n('Considera Estoque');
                    		} else {
                    		    field.widget.getField('estoque').label = ScreenService.i18n('Não Considera Estoque');
                    		}
                        }
                        else {
                             field.widget.getField('estoque').label = '';
                        }
                    }).catch(function(error) {
                        ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                    });   
                } else {
                    field.widget.getField('estoque').label = '';
                }
            }
        }
    };
    
    this.onlyNumbers = function(field) {
		if(isNaN(Number(field.value()))) {
			field.value(prevValue);
		} else {
			if(field.value() === "") {
				prevValue = "";
				field.value(0);
				field.value("");
				return false;
			}
			if(parseInt(Number(field.value())) === Number(field.value())) {
				field.value(parseInt(Number(field.value())).toString());
				field.value(Math.abs(field.value()));
				prevValue = field.value();
			} else {
				field.value(prevValue);
			}
		}
	};
	
	this.setPrevValue = function(field) {
		prevValue = field.value();
	};
    
    this.validaAcrecimos = function(field){
        
        if (field < 10000.00){
            return true;
        } else {
            MessageService.showMessageByCode("ACRESCIMO_MENOR_1000");
            return false;
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("INIPRODUCT_MUSTBELESSTHAN_FINPRODUCT");
            return false;
        }

        return true;
    };
    
    this.validaProdutoFinal = function(row) { 
        var aux = 'ZZZZZZZZZZZZZZZZZZZZ';
        var str = row.CDPRODFIN;
        var produto = str + aux.substr(0, aux.length - str.length); 
        return produto;
    };
    
    this.setDadosTela = function (args){
        if(args.getWidget('calculoNecessidadeComprasMerenda')) {
            let widget = args.getWidget('calculoNecessidadeComprasMerenda');
            
            widget.getField('PERIENTR').defaultValue = {
                start: getLocalVar('DTPROCESSA'),
                end: getLocalVar('DTPROCESSA')
                
            };    
        } else {
            var widget = args.getWidget('calculoNecessidadeCompras');
            var row =  widget.currentRow;
            
            widget.getField('PERIENTR').defaultValue = {
                start: getLocalVar('DTPROCESSA'),
                end: getLocalVar('DTPROCESSA')
                
            };
            
            General.callRestEngine('cmp_necessidadeCompras#/setDadosCalculo','Row',row).then(function(calback) {
                var resposta = calback.dataset.resposta;
                idutcardpadr = resposta.IDUTCARDPADR;
                grupo = resposta.CDGRUPPROD;
                idcalprevcon = resposta.IDCALPREVCON;
        		var filter =  [
        			{
        				'name': 'P_CDGRUPPROD',
        				'operator': '=',
        				'value' : resposta.CDGRUPPROD
        			},
        			{
        				'name': 'NRORG',
        				'operator': '=',
        				'value': getLocalVar('NRORG')
        			}
        		];
        		widget.getField('NMSUBGRPROD').dataSourceFilter = filter;
        			
        		if(resposta.IDPERACRNEC == 'N'){
        		    widget.getField('PEACRESCIMO').readOnly = true;
        		} else {
        		    widget.getField('PEACRESCIMO').readOnly = false;
        		}
        		
        		if(resposta.IDSISDOS == 3){
        		    widget.getField('CALENDARIO').setValue('S');
        		    widget.getField('CALENDARIO').readOnly = true;
        		} else {
        		    widget.getField('CALENDARIO').setValue('N');
        		    widget.getField('CALENDARIO').readOnly = false;
        		}
            }).catch(function(error) {
                ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
            });
        }
    };
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams (arr, defaultValue) {
        if (!Util.isEmptyOrBlank(arr)) {
            return '_' + arr.join('_') + '_';
        } else {
            return defaultValue !== undefined ? defaultValue : 'T';
        }
    }
    
    function montaParametrosPrevisoesAndDataLimiteSeguranca(row) {
        row.DTINI = row.PERIENTR.start;
        row.DTFIM = row.PERIENTR.end;
        row.PRODUTOFIN = self.validaProdutoFinal(row);
        row.GROUPFILI = row.CDGRUPFILI || null;
        row.CDFILIAL = concatArrayForParams(row.FILIAL);
    }
    
    this.abrePopupOperador = function() {
        const popupEnviarOperador = templateManager.container.getWidget('popupEnviarOperador');
        const widgetCalculo = templateManager.container.getWidget('calculoNecessidadeCompras');
        
        if(widgetCalculo.isValid()) {
            ScreenService.openPopup(popupEnviarOperador);
        }
    };
    
    this.confirmaCalcSegundoPlano = function() {
        const widgetCalculo = templateManager.container.getWidget('calculoNecessidadeCompras');
        const cdoperador = templateManager.container.getWidget('popupEnviarOperador').currentRow.CDOPERADOR;
        
        let listaOperador = cdoperador && Array.isArray(cdoperador) ? cdoperador.join('_') + '_' + getLocalVar('CDOPERADOR') : getLocalVar('CDOPERADOR');
        
        widgetCalculo.currentRow.LISTAOPERADOR = listaOperador;
        
        this.confirmaCalculo(widgetCalculo, true);
    };
    
    function montaParametrosMerenda(row) {
        row.DTINI = row.PERIENTR.start;
        row.DTFIM = row.PERIENTR.end;
        row.PRODUTOFIN = self.validaProdutoFinal(row);
        row.PEACRESCIMO = row.PEACRESCIMO ? row.PEACRESCIMO : 0;
    }
    
    this.confirmaCalculo = function(widget, segundoPlano) {
        if(widget.name == 'calculoNecessidadeComprasMerenda') {
            let row = widget.currentRow;
            row.TCDFILIAL = "";
            montaParametrosMerenda(row);
            if(widget.isValid() && self.validaDtinicial() && self.validaProduto(row.CDPRODINI, row.CDPRODFIN) && self.validaAcrecimos(row.PEACRESCIMO)) {
                ScreenService.confirmMessage('Confirma o cálculo?', 'question', function(success) {
                    General.callRestEngine('cmp_necessidadeCompras#/existeSolicitacao','Row',row).then(function(calback) {
                        let resposta = calback.dataset.resposta;
                        if(resposta.length != 0 ){
                            widget.container.getWidget('existemSolicitacoes').dataSource.data = resposta;
                            widget.container.getWidget('existemSolicitacoes').reload();
                            ScreenService.openPopup(widget.container.getWidget('existemSolicitacoes'));
                        } else {
                            self.calcula(widget, row);
                        }
                    }).catch(function(error) {
                        ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                    });    
                });   
            }
        } else {
            
            let row = widget.currentRow;
            row.TCDFILIAL = "";
            
            calculaSegundoPlano = segundoPlano;
            
            row.PEACRESCIMO = row.PEACRESCIMO ? row.PEACRESCIMO : 0;
            
            if(widget.isValid() && self.validaProduto(row.CDPRODINI, row.CDPRODFIN) && self.validaAcrecimos(row.PEACRESCIMO)) {
                
                ScreenService.confirmMessage('Confirma o cálculo?', 'question', function(success) {
                    
                    montaParametrosPrevisoesAndDataLimiteSeguranca(row);
                   
                    if(idutcardpadr == 'D' || idutcardpadr == 'S'){
                        General.callRestEngine('cmp_necessidadeCompras#/previsoes','Row',row).then(function(calback) {
                            var resposta = calback.dataset.resposta;
                            
                            if(resposta.length != 0 ){
    
                                widget.container.getWidget('previsoesbloqueadas').dataSource.data = resposta;
                                widget.container.getWidget('previsoesbloqueadas').reload();
                                ScreenService.openPopup(widget.container.getWidget('previsoesbloqueadas'));
                               
                            } else {
                                self.verificaSolicitacao(widget, row);
                            }
                        }).catch(function(error) {
                            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                        });
                    }else {
                        self.verificaSolicitacao(widget, row);
                    }    
                 
                });
            }
        }
    };
    
    this.previsoesBloqueadas = function(widget){
        let parentWidget = widget.getParent();
        
        ScreenService.confirmMessage('Confirma o cálculo mesmo com previões bloqueadas?', 'question', function(success) {
            ScreenService.closePopup();
            parentWidget.activate();
            //self.verificaSolicitacao(parentWidget, angular.copy(parentWidget.currentRow));
            self.verificaSolicitacao(parentWidget, parentWidget.currentRow);
        }, function(error){
            ScreenService.closePopup();
            parentWidget.activate();
        });
    };
    
    this.verificaSolicitacao = function(widget, row){
        row.SUBGRUPO = concatArrayForParams(row.NMSUBGRPROD, null);
        row.CDGRUPPROD = grupo;
        
        General.callRestEngine('cmp_necessidadeCompras#/existeSolicitacao','Row',row).then(function(calback) {
            let resposta = calback.dataset.resposta;
            if(resposta.length != 0 ){
                widget.container.getWidget('existemSolicitacoes').dataSource.data = resposta;
                widget.container.getWidget('existemSolicitacoes').reload();
                ScreenService.openPopup(widget.container.getWidget('existemSolicitacoes'));
            } else {
                self.calcula(widget, row);
            }
        });
    };
    
    this.existemSolicitacoes = function(widget){
        let parentWidget = widget.getParent();
        let rowParentWidget = parentWidget.currentRow;
        
        rowParentWidget.SUBGRUPO = concatArrayForParams(rowParentWidget.NMSUBGRPROD, null);
        rowParentWidget.CDGRUPPROD = grupo;
        
        ScreenService.closePopup();
        parentWidget.activate();
        //self.calcula(parentWidget, angular.copy(rowParentWidget));
        self.calcula(parentWidget, rowParentWidget);
    };
    
    this.calcula = function(widget, row) {
        row.TCDFILIAL = "";
        if(widget.isValid()) {
            if(widget.name == 'calculoNecessidadeComprasMerenda') {
                General.callRestEngine('cmp_necessidadeCompras#/GetPrxNeceCompMerenda', 'Row', row).then(function(calculo) {
                    if(calculo.dataset.resposta.NECECOMP === 'N') {
                        MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
        			} else {
        			    row.NECECOMP = calculo.dataset.resposta.NECECOMP[0].NRNECECOMP;
        			    General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliMerenda', 'Row', row).then(function(response) {
                            self.openPreviaCalculoNecessidadeCompras(row.NECECOMP);
                            MessageService.showMessageByCode("SOLCMP_SUCCESS");
                        }.bind()).catch(function(error) {
                            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                        });
        			}
                }.bind(row));
                
            } else {
                montaParametrosPrevisoesAndDataLimiteSeguranca(row);
                General.callRestEngine('cmp_necessidadeCompras#/dataLimiteSeguranca','Row',row).then(function(calback) {
                    row.DATFIMSEGU = calback.dataset.resposta.DATSEGU;
                    row.MSGBACK = "Parâmetros default de consumo devem ser informados.";
                    if(idcalprevcon !== 'N') {
                        if(idcalprevcon == 'S') {
                            MessageService.confirmMessageByCode("CONFIRM_CALC_PREV", {DATFIMSEGU: row.DATFIMSEGU}, Constants.confirmationMessage).then(() => {
                                General.callRestEngine('cmp_necessidadeCompras#/GetPrxConsPlan','Row',row).then(function(result) {
                                    if(!result.dataset.resposta.MSG){
                                        self.CalcNecesComp(row);
                                    }else{
                                        ScreenService.showMessage(result.dataset.resposta.MSG);
                                    }
                                    
                                }).catch(function(error) {
                                    ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n("Tempo limite de conexão excedido."), 'error', 'error');
                                }); 
                            }, function(error) {
                                self.CalcNecesComp(row);
                            });
                        } else{
                            General.callRestEngine('cmp_necessidadeCompras#/GetPrxConsPlan','Row',row).then(function(result) {
                                if(!result.dataset.resposta.MSG) {
                                    self.CalcNecesComp(row);
                                }else{
                                    ScreenService.showMessage(result.dataset.resposta.MSG);
                                }
                            }).catch(function(error) {
                                ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                            }); 
                        }       
                    } else{
                        self.CalcNecesComp(row);
                    }
                });
            }
        }   
    };

    this.CalcNecesComp = function(row)
    {
        General.callRestEngine('cmp_necessidadeCompras#/PrxNeceBkg','Row', row).then(function(retorno) {
            row.NECECOMP = retorno.dataset.resposta.NRNECECOMP;
            row.IDCALPREVCON = idcalprevcon;
            
            if(calculaSegundoPlano) {
                realizaCalculoSegundoPlano(row);
            } else {
                realizaCalcNeceComp(row);
            }
        }).catch(function(error){
            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'));
        });
    };
     
    function realizaCalculoSegundoPlano(row)
    {
        row.EMAILLOGADO = getLocalVar('EMAIL');
        
        return General.callRestEngine('cmp_necessidadeCompras#/calcNeceCompSegundoPlano', 'Row', row).then(function() {
            MessageService.showMessageByCode("CALC_SEG_PLAN", {NECECOMP: row.NECECOMP} , Constants.alertMessage);
            ScreenService.closePopup();
        });
    }

    function realizaCalcNeceComp(row) {
        nececomp = row.NECECOMP;
        extra = row.EXTRA;
        row.TCDFILIAL = "";
            
        return General.callRestEngine('cmp_necessidadeCompras#/GetPrxNeceComp', 'Row', row).then(function(calculo) {
            if(Array.isArray(row.FILIAL) && row.FILIAL.length === 1) {
                ScreenService.openWindow('cmp_necessidadeCompras#necessidade_de_compras').then(function() {
                    var widgetNecessidadeCompras = templateManager.container.getWidget('gridNeceComp');
                    
                    widgetNecessidadeCompras.dataSourceFilter = [
                        {
            				'name': 'P_NRNECECOMP',
            				'operator': '=',
            				'value' : row.NECECOMP
            			},
            			{
            				'name': 'P_DTINICIAL',
            				'operator': '=',
            				'value': row.DTINI
            			}
        			];
        			
        			if(calculo.dataset.resposta.NECECOMP === 'N') {
                        MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
        			}
        			
        			widgetNecessidadeCompras.CDFILIAL   = row.FILIAL[0];
        			widgetNecessidadeCompras.NECECOMP   = row.NECECOMP;
        			widgetNecessidadeCompras.CDPRODINI  = row.CDPRODINI;
        			widgetNecessidadeCompras.CDPRODFIN  = row.CDPRODFIN;
        			widgetNecessidadeCompras.DTINI      = row.PERIENTR.start;
        			widgetNecessidadeCompras.DTFIM      = row.PERIENTR.end;
        			
        			widgetNecessidadeCompras.reload().then(function() {
        			    widgetNecessidadeCompras.activate();
        			    widgetNecessidadeCompras.redraw();
        			});
                });
            } else {
                if(calculo.dataset.resposta.NECECOMP === 'N') {
                    MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
    			} else {
    			    var msg = 'Cálculo da Necessidade de Compras-Extra';
                    var param = {'NRNECECOMP': nececomp, 'EXTRA': extra, 'MENSAGEM': msg};
               
                    return General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp','Row',param).then(function() {
                        self.openPreviaCalculoNecessidadeCompras(nececomp);
                        MessageService.showMessageByCode("SOLCMP_SUCCESS");
                    });
    			}
            }
        }.bind(row));
    }
    
    this.setDataSource = function (fieldAgrupamento) {
        //field.setValue('');
        
        const row = fieldAgrupamento.widget.currentRow;
        const fieldFilial = fieldAgrupamento.widget.getField('FILIAL');
        
        if(!row.NMGRUPFILI) {
            fieldFilial.dataSource.name = "cmp#/crud/filial_ativa_oper";
            fieldFilial.dataSourceFilter = [
                {
    				'name': 'P_CDOPERADOR',
    				'operator': '=',
    				'value' : getLocalVar('CDOPERADOR')
    			},
    			{
    				'name': 'NRORG',
    				'operator': '=',
    				'value': getLocalVar('NRORG')
    			}     
            ];
        } else {
            fieldFilial.dataSource.name = "cmp#/filialgrupfili";
            fieldFilial.dataSourceFilter = [
                {
    				'name': 'CDOPERADOR',
    				'operator': '=',
    				'value' : getLocalVar('CDOPERADOR')
    			},
    			{
    				'name': 'CDGRUPFILI',
    				'operator': '=',
    				'value': row.CDGRUPFILI 
    			},
    			{
    				'name': 'CDREGIAO',
    				'operator': 'IS_NOT_NULL'
    			}
            ];
        }
        
        fieldFilial.reload();
    };
    
    // this.checkProjectCorp =  function(widget){
    //     if(!window.projectId){
    //         widget.getField('NMGRUPFILI').readOnly = true;
    //         widget.getField('NMGRUPFILI').reload();
    //         widget.getField('FILIAL').readOnly = true;
    //         widget.getField('FILIAL').template = "/field/select.html";
    //         widget.getField('FILIAL').setValue([ getLocalVar('CDFILIAL') ]);
    //         widget.getField('FILIAL').reload();
    //     }
    // };

    
    this.getExtra = function(){
        return extra;
    };
    
    this.openPreviaCalculoNecessidadeCompras = function(numeroPrevia) {
        ScreenService.openWindow('cmp_necessidadeCompras#cmp03800_previa_do_calculo_da_necessidade_de_compras').then(function() {
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').setValue(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').value(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').defaultValue = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = numeroPrevia;
            
            General.callRestEngine('cmp_necessidadeCompras#/crud/numPrevia', 'FilterData', {}).then(function(response) {
                const dataNumPrevia = response.dataset.numPrevia;
                let dadosPrevia = dataNumPrevia.filter(function(previa) {
                    return previa.NRNECECOMP === numeroPrevia;
                });
                dadosPrevia = dadosPrevia.length ? dadosPrevia[0] : dadosPrevia;
                
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').setValue({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').value({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').defaultValue = {
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                };
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.start = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.end = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedStart = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedEnd = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTINI = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTFIN = dadosPrevia.DTFIN.substr(0, 10);
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODINICIAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODFINAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMFILIAL').validations;
            });
        });
    };
    
    this.retornaCookieListaOperador = function()
    {
        const nomeCookie = 'LISTA_OPERADOR_CALCULO_SEGUNDO_PLANO';
        const popupEnviarOperador = templateManager.container.getWidget('popupEnviarOperador');
        const fieldCdoperador = popupEnviarOperador.getField('CDOPERADOR');
        const cdoperador = popupEnviarOperador.currentRow.CDOPERADOR;
        
        if(!cdoperador || !cdoperador.length) {
            General.callRestEngine('cmp_necessidadeCompras#/retornaCookie','Row', { 'NOME_COOKIE': nomeCookie } ).then(function(valorCookie) {
                valorCookie = valorCookie.messages[0].message;
                
                if(valorCookie) {
                    valorCookie = valorCookie.split('_');
                    
                    valorCookie = valorCookie.filter(function(cdoperador) {
                        return cdoperador !== getLocalVar('CDOPERADOR');
                    });
                    
                    fieldCdoperador.setValue(valorCookie);
                    fieldCdoperador.reload();
                }
                
            });
        }
        
    };
};

Configuration(function (ContextRegister) {
	ContextRegister.register('CalculoDaNecessidadeDeComprasController', CalculoDaNecessidadeDeComprasController);
});